#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "BxlLabelAPI.h"
#include "bxlConst.h"


int connectToPrinter()
{
	int input;
	int ret;
	char port[128] = {0x00, };

	printf("\n\t [Connect to the Bixolon printer] \n");
	printf("\t\t  1.USB\n");
	printf("\t\t  2.Serial\n");
	printf("\t\t  3.Parallel\n");
	printf("\t\t  4.Bluetooth\n");
	printf("\t\t  5.Ethernet/WLAN\n");
	printf("\t\t  6.Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("Please select the connected interface with the printer.\n");
		printf("Input number : ");
		scanf("%d", &input);

		if (1 == input)
		{
			ret = ConnectToPrinter("USB:");
		}
		else if (2 == input)
		{
			unsigned long baudrate = 0;

			while (1)
			{
				printf("\nPlease input the baudrate of serial I/F\n");
				printf("Input number : ");
				scanf("%lu", &baudrate);

				if (2400 != baudrate && 4800 != baudrate && 9600 != baudrate && 19200 != baudrate && 
						38400 != baudrate && 57600 != baudrate && 115200 != baudrate)
				{
					printf("\nWrong input.\n");
					continue;
				}

				break;
			}

			sprintf(port, "serial:%lu", baudrate);

			// input type
			// serial:baudrate
			// /dev/ttyX:baudrate
			ret = ConnectToPrinter(port);
		}
		else if (3 == input)
		{
			// input type
			// parallel
			// /dev/lpX
			ret = ConnectToPrinter("parallel");
		}
		else if (4 == input)
		{
			while (1)
			{
				printf("\nPlease input the mac address of bluetooth priner\n");
				printf("Input the address : ");
				scanf("%s", port);

				if (':' == port[2] && ':' == port[5] && ':' == port[8] &&
						':' == port[11] && ':' == port[14])
				{
					break;
				}

				printf("\nWrong input.\n");
			}

			// input type
			// xx:xx:xx:xx:xx:xx
			ret = ConnectToPrinter(port);
		}
		else if (5 == input)
		{
			char *tmp;

			while (1)
			{
				printf("\nPlease input the IP address of Ethernet or Wlan printer\n");
				printf("Input the address : ");
				scanf("%s", port);

				tmp = strchr(port, ':');
				if (NULL == tmp)
				{
					printf("\nWrong input.\n");

					continue;
				}

				break;
			}

			// input type
			// xxx.xxx.xxx.xxx:xxxx
			ret = ConnectToPrinter(port);
		}
		else if (6 == input)
		{
			return input;
		}
		else 
		{
			printf("\nWrong input.\n\n");

			continue;
		}


		if (SUCCESS == ret)
		{
			break;
		}
		else
		{
			printf("\nFailed to connect to the printer.\n");
			sleep(1);
		}
	}

	printf("\nSuccessed to connect to the printer.\n");
	sleep(1);

	return ret;
}

int setProperties()
{
	int input;
	//int ret = SUCCESS;

	printf("\n\t [Set the Properties of the printer] \n");
	printf("\t\t  1.Speed\n");
	printf("\t\t  2.Density\n");
	printf("\t\t  3.Orientation\n");
	printf("\t\t  4.Cutter\n");
	printf("\t\t  5.Back Feed\n");
	printf("\t\t  6.Paper\n");
	printf("\t\t  7.Printing Typed\n");
	printf("\t\t  8.Margin\n");
	printf("\t\t  9.Offset\n");
	printf("\t\t  10.Rewinder(Supports only XT5-40,XT5-43,XT5-46)\n");
	printf("\t\t  11.Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("\n Please select the property to set.\n");
		printf(" Input number : ");
		scanf("%d", &input);


		if (1 == input)		// speed
		{
			int speed;

			printf("[Set Printing Speed]\n");
			printf("\n");
			printf("1. 2.5 ips\n");
			printf("2. 3.0 ips\n");
			printf("3. 4.0 ips\n");
			printf("4. 5.0 ips\n");
			printf("5. 6.0 ips\n");
			printf("6. 7.0 ips\n");
			printf("7. 8.0 ips(XT5-40 and XT5-43 Only)\n");
			printf("8. 9.0 ips(XT5-40 and XT5-43 Only)\n");
			printf("9. 10.0 ips(XT5-40 and XT5-43 Only)\n");
			printf("10. 11.0 ips(XT5-40 Only)\n");
			printf("11. 12.0 ips(XT5-40 Only)\n");
			printf("12. 13.0 ips(XT5-40 Only)\n");
			printf("13. 14.0 ips(XT5-40 Only)\n");
			

			printf("\nInput number : ");
			scanf("%d", &speed);

			if (1 == speed)
			{
				SetSpeed(SPEED_25);
			}
			else if (2 == speed)
			{
				SetSpeed(SPEED_30);
			}
			else if (3 == speed)
			{
				SetSpeed(SPEED_40);
			}
			else if (4 == speed)
			{
				SetSpeed(SPEED_50);
			}
			else if (5 == speed)
			{
				SetSpeed(SPEED_60);
			}
			else if (6 == speed)
			{
				SetSpeed(SPEED_70);
			}
			else if (7 == speed)
			{
				SetSpeed(SPEED_80);
			}
			else if (8 == speed)
			{
				SetSpeed(SPEED_90);
			}
			else if (9 == speed)
			{
				SetSpeed(SPEED_100);
			}
			else if (10 == speed)
			{
				SetSpeed(SPEED_110);
			}
			else if (11 == speed)
			{
				SetSpeed(SPEED_120);
			}
			else if (12 == speed)
			{
				SetSpeed(SPEED_130);
			}
			else if (13 == speed)
			{
				SetSpeed(SPEED_140);
			}
			else
			{
				SetSpeed(SPEED_50);
			}

		}
		else if (2 == input)	// density
		{
			int density; 

			printf("[Set Printing Density]\n");
			printf("\n");
			printf("Input density (0 ~ 20) : ");
			scanf("%d", &density);

			SetDensity(density);
		}
		else if (3 == input)	// orientation
		{
			int orientation;

			printf("[Set Printing Orientation]\n");
			printf("\n");
			printf("1. Top to Bottom\n");
			printf("2. Bottom to Top\n");

			printf("\nInput number : ");
			scanf("%d", &orientation);

			if (2 == orientation)
			{
				SetOrientation(BOTTOM_TO_TOP);
			}
			else
			{
				SetOrientation(TOP_TO_BOTTOM);
			}
		}
		else if (4 == input)	// cutter
		{
			int enable;

			printf("[Set Auto Cutter]\n");
			printf("\n");
			printf("1. Enable\n");
			printf("2. Disable\n");

			printf("\nInput number : ");
			scanf("%d", &enable);

			if (2 == enable)
			{
				SetCutter(false, 1);
			}
			else
			{
				SetCutter(true, 1);
			}
		}
		else if (5 == input)	// back feed
		{
			int enable;

			printf("[Set Back Feed]\n");
			printf("\n");
			printf("1. Enable\n");
			printf("2. Disable\n");

			printf("\nInput number : ");
			scanf("%d", &enable);

			if (2 == enable)
			{
				SetBackFeed(false);
			}
			else
			{
				SetBackFeed(true);
			}
		}
		else if (6 == input)	// paper
		{
			// paper width 832 dot
			// paper height 1216 dot
			// GAP paper
			// GAP length 20 dot
			// offset 0
			SetPaper(832, 1216, MEDIA_GAP, 20, 0);
		}
		else if (7 == input)	// prting type
		{
			int type;

			printf("[Set Printing Type]\n");
			printf("\n");
			printf("1. Direct Thermal\n");
			printf("2. Thermal Transfer\n");

			printf("\nInput number : ");
			scanf("%d", &type);

			if (2 == type)
			{
				SetPrintingType(PRINTING_TRANSFER);
			}
			else
			{
				SetPrintingType(PRINTING_DIRECT);
			}
		}
		else if (8 == input)	// margin
		{
			int hMargin, vMargin;

			printf("[Set Margin]\n");
			printf("\n");
			printf("Input Horizontal Margin : ");
			scanf("%d", &hMargin);
			printf("\n");
			printf("Input Vertical Margin : ");
			scanf("%d", &vMargin);

			SetMargin(hMargin, vMargin);
		}
		else if (9 == input)	// offset
		{
			int offset;

			printf("[Set Offset]\n");
			printf("\n");
			printf("Input Offset : ");
			scanf("%d", &offset);

			SetOffset(offset);
		}
		else if( 10 == input)
		{
			int rewind;
			printf("Set Rewinder\n");
			printf("\n");
			printf("1. Enable\n");
			printf("2. Disable\n");

			printf("\nInput number : ");
			scanf("%d", &rewind);

			if (2 == rewind)
			{
				SetRewinder(false);
			}
			else
			{
				SetRewinder(true);
			}
		}
		else if (11 == input)
		{
			return input;
		}
		else
		{
			printf("\nWrong input.\n\n");

			continue;
		}
	}

	return SUCCESS;
}


int printText()
{
	PrintDeviceFontW("한국어", 30, 50, DEVICE_KOR_24X24, 1, 1, ROTATE_0, false, CP_EUCKR);
	PrintDeviceFont("DEVICE FONT TEST", 30, 50, DEVICE_ENG_9X15, 1, 1, ROTATE_0, false);
	PrintDeviceFont("DEVICE FONT TEST", 30, 50, DEVICE_ENG_9X15, 1, 1, ROTATE_0, false);
	PrintDeviceFont("DEVICE FONT TEST", 30, 150, DEVICE_ENG_24X38, 1, 1, ROTATE_0, false);
	PrintDeviceFont("DEVICE FONT TEST", 30, 250, DEVICE_ENG_28X44, 1, 1, ROTATE_0, false);

	Prints(1, 1);


	PrintVectorFontW("한국어", 30, 50, VECTOR_KS5601, 10, 10, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT, CP_CP949); 
	PrintVectorFont("VECTOR FONT TEST", 30, 50, VECTOR_ASCII, 10, 10, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	PrintVectorFont("VECTOR FONT TEST", 30, 50, VECTOR_ASCII, 10, 10, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	PrintVectorFont("VECTOR FONT TEST", 30, 150, VECTOR_ASCII, 20, 20, 3, true, false, true, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	PrintVectorFont("VECTOR FONT TEST", 30, 250, VECTOR_ASCII, 30, 30, 3, false, true, true, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 

	Prints(1, 1);

	return SUCCESS;
}


int print1DBarcode()
{
	PrintVectorFont("CODE 39", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 90, BAR_CODE39, 2, 5, 100, ROTATE_0, 1);

	PrintVectorFont("CODE 128", 70, 230, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 280, BAR_CODE128, 2, 5, 100, ROTATE_0, 1);

	Prints(1, 1);


	PrintVectorFont("Interleaved 2of5", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 90, BAR_I2OF5, 2, 5, 100, ROTATE_0, 1);

	PrintVectorFont("CODABAR", 70, 230, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 280, BAR_CODABAR, 2, 5, 100, ROTATE_0, 1);

	Prints(1, 1);


	PrintVectorFont("CODE 93", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 90, BAR_CODE93, 2, 5, 100, ROTATE_0, 1);

	PrintVectorFont("UPC-A", 70, 230, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 280, BAR_UPCA, 2, 5, 100, ROTATE_0, 1);

	Prints(1, 1);


	PrintVectorFont("UPC-E", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 90, BAR_UPCE, 2, 5, 100, ROTATE_0, 1);

	PrintVectorFont("EAN 13", 70, 230, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 280, BAR_EAN13, 2, 5, 100, ROTATE_0, 1);

	Prints(1, 1);


	PrintVectorFont("EAN 8", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 90, BAR_EAN8, 2, 5, 100, ROTATE_0, 1);

	PrintVectorFont("EAN 128", 70, 230, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	Print1DBarcode("123456789012", 70, 280, BAR_EAN128, 2, 5, 100, ROTATE_0, 1);

	Prints(1, 1);

	return SUCCESS;
}

int print2DBarcode()
{
	PrintVectorFont("MAXICODE", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	PrintMaxiCode("990,840,06840,THIS IS A TEST OF MODE 0 BIXOLON LABEL PRINTER", 70, 90, MAXICODE_MODE0);


	PrintVectorFont("PDF417", 70, 340, VECTOR_ASCII, 20, 20, 3, false, false, false, 
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT); 
	PrintPDF417("BIXOLON Label Printer, This is Test Printing", 70, 390, 30, 5, PDF417_ECL0, 
				PDF417_COMP_TEXT, true, 1, 3, 10, 0);

	Prints(1, 1);


	PrintVectorFont("QR Code", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintQRCode("ABCDEFGHIJKLMN1234567890", 70, 90, 1, QRCODE_ECC7, 4, ROTATE_0);


	PrintVectorFont("Data Matrix", 70, 240, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintDataMatrix("BIXOLON Label Printer", 70, 290, 4, false, ROTATE_0);

	Prints(1, 1);


	PrintVectorFont("Aztec", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintAztec("THIS IS AZTEC BARCODE TESTTHIS IS AZTEC BARCODE TEST", 70, 90, 5, 0, 0, true, 1, 1, ROTATE_0);

	PrintVectorFont("Code 49", 70, 240, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintCode49("12345ABC", 70, 290, 2, 7, 22, 2, 7, ROTATE_0);

	Prints(1, 1);


	PrintVectorFont("CODABLOCK", 70, 40, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintCODABLOCK("BIXOLON BARCODE TEST 123BIXOLON BARCODE TEST 123BIXOLON BARCODE TEST 123",
			      70, 90, 2, 5, 30, false, 30, 'F', 4);

	PrintVectorFont("Micro PDF", 70, 240, VECTOR_ASCII, 20, 20, 3, false, false, false,
					ROTATE_0, ALIGNMENT_LEFT, LEFT_TO_RIGHT);
	PrintMicroPDF("ABCDEFGHIJKLMN1234567890", 70, 290, 2, 6, 8, ROTATE_0);

	Prints(1, 1);

	return SUCCESS;
}

int printSample()
{
	char *cmd1 = "B2595,180,M,0,'999,840,06810,7317,BIXOLON LABEL PRINTER'";
	char *cmd2 = "B2240,945,P,8,8,0,0,0,1,2,14,0,'BIXOLON Label Printer, This is for test.'";

	PrintBlock(4100, 40, 8000, 150, BLOCK_OVERWRITE, 0);

	PrintBlock(58, 164, 838, 170, BLOCK_OVERWRITE, 0);
	PrintBlock(58, 410, 824, 415, BLOCK_OVERWRITE, 0);
	PrintBlock(588, 170, 593, 413, BLOCK_OVERWRITE, 0);
	PrintBlock(58, 616, 824, 621, BLOCK_OVERWRITE, 0);
	PrintBlock(60, 781, 826, 786, BLOCK_OVERWRITE, 0);
	PrintBlock(58, 928, 824, 933, BLOCK_OVERWRITE, 0);
	PrintBlock(281, 783, 286, 932, BLOCK_OVERWRITE, 0);
	PrintBlock(526, 784, 531, 933, BLOCK_OVERWRITE, 0);

	PrintDeviceFont("BIXOLON", 440, 55, DEVICE_ENG_48X76, 1, 1, ROTATE_0, false);	

	PrintDeviceFont("SHIP TO:", 60, 174, DEVICE_ENG_24X38, 1, 1, ROTATE_0, false);	
	PrintDeviceFont("BIXOLON", 60, 134, DEVICE_ENG_19X30, 1, 1, ROTATE_0, true);
	PrintDeviceFont("7th FL, MiraeAsset Venture Tower,", 60, 280, DEVICE_ENG_16X25, 1, 1, ROTATE_0, false);
	PrintDeviceFont("685, Sampyeong-dong, Bundang-gu,", 60, 310, DEVICE_ENG_16X25, 1, 1, ROTATE_0, false);
	PrintDeviceFont("Seongnam-si, Gyeonggi-do,", 60, 340, DEVICE_ENG_16X25, 1, 1, ROTATE_0, false);
	PrintDeviceFont("463-400, KOREA", 60, 370, DEVICE_ENG_16X25, 1, 1, ROTATE_0, false);

	PrintDeviceFont("POSTAL CODE", 66, 421, DEVICE_ENG_12X20, 1, 1, ROTATE_0, false);
	PrintDeviceFont("DESTINATION", 543, 798, DEVICE_ENG_12X20, 1, 1, ROTATE_0, false);
	PrintDeviceFont("30 Kg", 82, 841, DEVICE_ENG_32X50, 1, 1, ROTATE_0, true);
	PrintDeviceFont("WEIGHT:", 65, 798, DEVICE_ENG_12X20, 1, 1, ROTATE_0, false);
	PrintDeviceFont("DELIVERY NO:", 299, 798, DEVICE_ENG_12X20, 1, 1, ROTATE_0, false);
	PrintDeviceFont("AWB:", 63, 630, DEVICE_ENG_12X20, 1, 1, ROTATE_0, false);
	PrintDeviceFont("425518", 314, 841, DEVICE_ENG_32X50, 1, 1, ROTATE_0, true);
	PrintDeviceFont("8741493121", 144, 627, DEVICE_ENG_19X30, 1, 1, ROTATE_0, false);
	PrintDeviceFont("ICN", 605, 841, DEVICE_ENG_32X50, 1, 1, ROTATE_0, true);

	Print1DBarcode("1234567890", 109, 458, BAR_CODE39, 4, 8, 137, ROTATE_0, true);
	Print1DBarcode("8741493121", 167, 662, BAR_CODE93, 4, 8, 90, ROTATE_0, true);


	// print a MAXICODE
	DirectIO(cmd1, strlen(cmd1), NULL, 0);

	// print a PDF417
	DirectIO(cmd2, strlen(cmd2), NULL, 0);

	PrintCircle(40, 1055, 3, 2);

	PrintQRCode("QRCode sample test 123", 66, 940, 2, QRCODE_ECC15, 4, ROTATE_0); 

	Prints(1, 1);

	return SUCCESS;
}

int main(void)
{
	int menu_flag = 0;
	int ret;

	int input;
	int status;

	while (1)
	{
		system("clear");
		printf("\n\n   [Bixolon Label Printer SDK Sample]   \n\n");

		if (0 == menu_flag)
		{
			printf("\t 1. Connect to the printer\n");
		}
		else 
		{
			printf("\t 1. Connect to the printer\n");
			printf("\t  - Connected!\n");
		}
		printf("\t 2. Set Properties\n");
		printf("\t 3. Print Sample\n");
		printf("\t 4. Print Text\n");
		printf("\t 5. Print Barcode\n");
		printf("\t 6. Print Image\n");
		printf("\t 7. Print Block\n");
		printf("\t 8. Check Status\n");
		printf("\t 9. Calibrate Media\n");
		printf("\t 10. Exit\n");

		printf("  input number : ");
		scanf("%d", &input);


		if (1 == input)		// connect to the printer
		{
			ret = connectToPrinter();
			if (6 == ret)
			{
				continue;
			}

			if (SUCCESS != ret)
			{
				printf("\n Failed to connect to printer.");

				return -1;
			}

			menu_flag = 1;
		}
		else if (2 == input) 	// set properties
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			ret = setProperties();
			if (10 == ret )
			{
				continue;
			}

			if (SUCCESS != ret)
			{
				printf("\n Failed to connect to printer.");
				continue;
			}

			menu_flag = 2;
		}
		else if (3 == input) 	// print sample
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}
			
			printSample();

			menu_flag = 3;
		}
		else if (4 == input) 	// print text
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			ret = printText();

			menu_flag = 4;
		}
		else if (5 == input) 	// print barcode
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			print1DBarcode();
			print2DBarcode();

			menu_flag = 5;
		}
		else if (6 == input) 	// print image
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			PrintBitmap("image.bmp", 50, 50, false);
			PrintBitmap("image.bmp", 50, 350, true);
			Prints(1, 1);

			menu_flag = 6;
		}
		else if (7 == input) 	// print Block
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			PrintBlock(100, 50, 350, 55, BLOCK_OVERWRITE, 0);
			PrintBlock(100, 50, 350, 150, BLOCK_SLOPE, 10);
			PrintBlock(100, 150, 350, 350, BLOCK_BOX, 10);
			Prints(1, 1);

			menu_flag = 7;
		}
		else if (8 == input) 	// check status
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			status = CheckPrinterStatus();

			if (status & STS_RIBONEND)
			{
				printf("\n status : ribon end\n");
			}

			if (status & STS_GAPERROR)
			{
				printf("\n status : gap error\n");
			}

			if (status & STS_TPHOVERHEAT)
			{
				printf("\n status : TPH overheat\n");
			}

			if (status & STS_CUTTERJAM)
			{
				printf("\n status : cutter jam\n");
			}

			if (status & STS_COVEROPEN)
			{
				printf("\n status : cover open\n");
			}

			if (status & STS_PAPEREMPTY)
			{
				printf("\n status : paper empty\n");
			}

			if (0x00 == status)
			{
				printf("\n status : Normal\n");
			}

			sleep(1);

			menu_flag = 8;
		}
		else if (9 == input) 	// calibrate media
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			CalibrateMedia();

			menu_flag = 9;
		}
		else if (10 == input) 	// exit
		{
			DisconnectPrinter();			
			break;
		}
		else 
		{
			printf("Wrong Input!!\n");

			continue;
		}
	}

	return 0;
}

